--Program to translate characters from DOS to WINDOWS and vice-versa.
--Author: R. M. Forno - Version 1.0 - 2000/08/24

--Representation of national characters differs between DOS and WINDOWS.
--This program translates text files from one to the other representation.
--Usage:
--C:>ex transl DOSTOWIN <input_file> <output_file>
--Or:
--C:>ex transl WINTODOS <input_file> <output_file>
--When using the compiled version, replace 'ex transl' by 'transl'

--Not all national characters are included in sequences 'dos' and 'win'.
--If neccessary, add your national characters to both of them.
--Characters in 'win' shold correspond, when viewed with a WINDOWS program,
-- to those in 'dos' when viewed with a DOS program.

include wildcard.e
sequence dos, win, c, inputfile, outputfile, direction, dostowin, wintodos
dos = "遚냈~ؙ"
win = "ѿǺ~"

procedure init()
    dostowin = repeat(0, 256)
    for i = 2 to 256 do
	dostowin[i] = i - 1
    end for
    wintodos = dostowin
    for i = 1 to length(win) do
	dostowin[dos[i] + 1] = win[i]
	wintodos[win[i] + 1] = dos[i]
    end for
end procedure

procedure translate()
    integer d, finput, foutput, a
    init()
    c = command_line()
    if length(c) < 5 then
	printf(1, "%s\n", 
	{"You need 3 parameters: direction, input file name and output file name"})
	abort(3)
    end if
    direction = upper(c[3])
    inputfile = c[4]
    outputfile = c[5]
    if equal(direction, "DOSTOWIN") then
	d = 0
    elsif equal(direction, "WINTODOS") then
	d = 1
    else
	printf(1, "%s\n",
	 {"Error - 1st parameter should be DOSTOWIN or WINTODOS"})
	abort(1)
    end if
    finput = open(inputfile, "r")
    if finput < 0 then
	printf(1, "%s\n", {"Can't open input file " & inputfile})
	abort(2)
    end if
    foutput = open(outputfile, "w")
    if foutput < 0 then
	printf(1, "%s\n", {"Can't open output file" & outputfile})
    end if
    if d then
	while 1 do
	    a = getc(finput)
	    if a < 0 then
		exit
	    end if
	    puts(foutput, wintodos[a + 1])
	end while
    else
	while 1 do
	    a = getc(finput)
	    if a < 0 then
		exit
	    end if
	    puts(foutput, dostowin[a + 1])
	end while
    end if
end procedure

translate()
